#include <windows.h>
#include "bmpio.h"
#include "resource.h"

LPCSTR szWindowClass = "SAMPLE_CLASS";
LPCSTR szWindowTitle = "bmpio.dlleXg";

LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
                         WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT ps;
    HDC hdc;
    static HDC hBmpDC;
    static HBITMAP hOldBmp;
    static int bmpWidth=0;
    static int bmpHeight=0;

    switch (message) {
		case WM_CREATE:
			hdc=GetDC(hWnd);
			hBmpDC=CreateCompatibleDC(hdc);
			hOldBmp=SelectObject(hBmpDC,CreateCompatibleBitmap(hdc,10,10));
			ReleaseDC(hWnd,hdc);
			break;
	    case WM_COMMAND:
    	    switch (LOWORD(wParam)) {
				case IDM_TEST1:
					/*bmp쐬ƕۑ̃eXg*/
					{
						bmp_t* bmp;
						int i;
						bmp=bmpMake(100,100);
						for(i=0;i<100;i++) {
							getBmpXY(bmp,50,i).r=255;
							getBmpXY(bmp,50,i).g=0;
							getBmpXY(bmp,50,i).b=0;
							getBmpXY(bmp,i,50).r=0;
							getBmpXY(bmp,i,50).g=0;
							getBmpXY(bmp,i,50).b=255;
						}
						bmpSave(bmp,"bmp\\test1_full.bmp",BMP_FULL,0,NULL);
						bmpSave(bmp,"bmp\\test1_256.bmp",BMP_256,COLORTABLE_DEFAULT,NULL);
						bmpSave(bmp,"bmp\\test1_16.bmp",BMP_16,COLORTABLE_DEFAULT,NULL);
						bmpSave(bmp,"bmp\\test1_mono.bmp",BMP_MONO,COLORTABLE_DEFAULT,NULL);
						bmpFree(bmp);
					}
					MessageBox(hWnd,"eXgI܂B","",
						MB_OK | MB_ICONINFORMATION); 
					break;
				case IDM_TEST2:
					/*BMPǂݍ݂ƕۑ̃eXg*/
					{
						OPENFILENAME ofn={0};
						char filename[1024]={0};
						bmp_t* bmp;
						bmp_t* edbmp;
						/*t@C߂*/
						ofn.lStructSize=sizeof(ofn);
						ofn.hwndOwner=hWnd;
						ofn.lpstrFilter="rbg}bvt@C(*.bmp)\0*.bmp\0\0"; 
						ofn.nFilterIndex=1;
						ofn.lpstrFile=filename;
						ofn.nMaxFile=sizeof(filename);
						ofn.Flags=OFN_CREATEPROMPT | OFN_FILEMUSTEXIST |
							OFN_HIDEREADONLY | OFN_NOCHANGEDIR |
							OFN_PATHMUSTEXIST;
						ofn.lpstrDefExt="bmp";
						if(!GetOpenFileName(&ofn))break;
						/*{̃eXg*/
						bmp=bmpLoad(filename);
						bmpSave(bmp,"bmp\\test2_full.bmp",BMP_FULL,0,NULL);
						bmpSave(bmp,"bmp\\test2_256.bmp",BMP_256,COLORTABLE_AUTODETECT,NULL);
						edbmp=bmpCopy(bmp);
						bmpErrorDiffusion(edbmp,BMP_256);
						bmpSave(edbmp,"bmp\\test2_256_ed.bmp",BMP_256,COLORTABLE_DEFAULT,NULL);
						bmpFree(edbmp);
						bmpSave(bmp,"bmp\\test2_16.bmp",BMP_16,COLORTABLE_AUTODETECT,NULL);
						edbmp=bmpCopy(bmp);
						bmpErrorDiffusion(edbmp,BMP_16);
						bmpSave(edbmp,"bmp\\test2_16_ed.bmp",BMP_16,COLORTABLE_DEFAULT,NULL);
						bmpFree(edbmp);
						bmpSave(bmp,"bmp\\test2_mono.bmp",BMP_MONO,COLORTABLE_AUTODETECT,NULL);
						edbmp=bmpCopy(bmp);
						bmpErrorDiffusion(edbmp,BMP_MONO);
						bmpSave(edbmp,"bmp\\test2_mono_ed.bmp",BMP_MONO,COLORTABLE_DEFAULT,NULL);
						bmpFree(edbmp);
						bmpFree(bmp);
					}
					MessageBox(hWnd,"eXgI܂B","",
						MB_OK | MB_ICONINFORMATION); 
					break;
				case IDM_TEST3:
					/*HBITMAPƂ̘Ag̃eXg*/
					{
						OPENFILENAME ofn={0};
						char filename[1024]={0};
						bmp_t* bmp;
						bmp_t* bmp2;
						HBITMAP hNewBmp;
						/*t@C߂*/
						ofn.lStructSize=sizeof(ofn);
						ofn.hwndOwner=hWnd;
						ofn.lpstrFilter="rbg}bvt@C(*.bmp)\0*.bmp\0\0"; 
						ofn.nFilterIndex=1;
						ofn.lpstrFile=filename;
						ofn.nMaxFile=sizeof(filename);
						ofn.Flags=OFN_CREATEPROMPT | OFN_FILEMUSTEXIST |
							OFN_HIDEREADONLY | OFN_NOCHANGEDIR |
							OFN_PATHMUSTEXIST;
						ofn.lpstrDefExt="bmp";
						if(!GetOpenFileName(&ofn))break;
						/*{̃eXg*/
						bmp=bmpLoad(filename);
						hNewBmp=bmpSaveToHandle(hBmpDC,bmp);
						bmp2=bmpLoadFromHandle(hBmpDC,hNewBmp);
						DeleteObject(SelectObject(hBmpDC,hNewBmp));
						bmpWidth=getBmpWidth(bmp);
						bmpHeight=getBmpHeight(bmp);
						bmpSave(bmp2,"bmp\\test3.bmp",BMP_FULL,0,NULL);
						bmpFree(bmp);
						bmpFree(bmp2);
						InvalidateRect(hWnd,NULL,TRUE);
					}
					MessageBox(hWnd,"eXgI܂B","",
						MB_OK | MB_ICONINFORMATION); 
					break;
        		default:
            		return DefWindowProc(hWnd, message, wParam, lParam);
			}
        	break;
	    case WM_PAINT:
    	    hdc = BeginPaint(hWnd, &ps);
    	    if(bmpWidth!=0 && bmpHeight!=0) {
				BitBlt(hdc,0,0,bmpWidth,bmpHeight,hBmpDC,0,0,SRCCOPY);
			}
        	EndPaint(hWnd, &ps);
        	break;
    	case WM_DESTROY:
			DeleteObject(SelectObject(hBmpDC,hOldBmp));
			DeleteDC(hBmpDC);
        	PostQuitMessage(0);
        	break;
    	default:
        	return DefWindowProc(hWnd, message, wParam, lParam);
   	}

    return 0;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
    MSG msg;
    WNDCLASSEX wcex;
    HWND hWnd;

    wcex.cbSize = sizeof(WNDCLASSEX);

    wcex.style          = CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc    = (WNDPROC)WndProc;
    wcex.cbClsExtra     = 0;
    wcex.cbWndExtra     = 0;
    wcex.hInstance      = hInstance;
    wcex.hIcon          = LoadIcon(NULL,IDI_APPLICATION);
    wcex.hCursor        = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
    wcex.lpszMenuName   = "MYMENU";
    wcex.lpszClassName  = szWindowClass;
    wcex.hIconSm        = NULL;

    RegisterClassEx(&wcex);

    hWnd = CreateWindow(szWindowClass,
        szWindowTitle, WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
        NULL, NULL, hInstance, NULL);

    if (!hWnd)
        return FALSE;

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

    while (GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return msg.wParam;
}
